

PARAMSIZE typedef BYTE
FLOATSIZE typedef REAL10
TRUE   equ 1
FALSE  equ 0

.data
stack_struct STRUCT 
  BP_ dd 0
  SP_ dd 0
  maxSize dd 0
stack_struct ENDS


.code

; #########################################################################
; Zweck: legt einen neuen Stack in einem Speicherbreich an (Speicherbereich muss vom Caller
; reserviert werden!)
; Parameter: stackAddr: Adresse des Speichers, der fr den Stack genutzt werden soll
; diese Speicheradresse wird bei allen Stackoperationen erwartet
; stack_size=groesse des zur verfuegung gestellen Speichers
; Rueckgabe: keine

stackNew proc stackAddr:DWORD,stack_size:DWORD
assume ecx:PTR stack_struct
  mov ecx,stackAddr

  mov eax, ecx
  add eax, sizeof stack_struct
  mov [ecx].BP_,eax ;direkt nach Verwaltuntsstruktur beginnt der genutze Speicher
  sub eax,sizeof PARAMSIZE 
  mov [ecx].SP_,eax
  mov eax, ecx
  add eax,stack_size  
  mov [ecx].maxSize,eax
  
  ret
stackNew endp

; #########################################################################
; Parameter: stackAddr: Pointer auf den Stack, gleiche Adresse wie bei stackNew
; Parameter: es werden NUR BYTEs abgelegt
; Rueckgabe: keine
; Hint: vorher stackIsFull nutzen!

stackPush proc stackAddr:DWORD,param:PARAMSIZE
assume ecx:PTR stack_struct
  mov ecx,stackAddr
  mov edx,[ecx].SP_
  
  
  add [ecx].SP_, sizeof PARAMSIZE  
  add edx, sizeof PARAMSIZE
  mov al, param
  mov PARAMSIZE ptr [edx],al 
  ret  
stackPush endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Rueckgabe: in EAX das oberste Stackelement
; Hint: vorher stackIsEmpty nutzen!

stackPop proc stackAddr:DWORD
assume ecx:PTR stack_struct
  mov ecx,stackAddr
  mov eax,[ecx].SP_
  sub [ecx].SP_,sizeof PARAMSIZE
  movzx eax,byte ptr[eax]
  ret  
stackPop endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Rueckgabe: in EAX das oberste Stackelement
; Hint: vorher stackIsEmpty nutzen!

stackTop proc stackAddr:DWORD
assume ecx:PTR stack_struct
  mov ecx,stackAddr
  mov eax,[ecx].SP_    
  movzx eax,byte ptr [eax] 
  ret  
stackTop endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Rueckgabe: TRUE(=1), wenn leer, ansonsten FALSE(=0)

stackIsEmpty proc stackAddr:DWORD
assume ecx:PTR stack_struct
  mov ecx,stackAddr
  mov eax, FALSE
  mov edx,[ecx].SP_      
  cmp edx,[ecx].BP_
  jge @f
    mov eax,TRUE
  @@:  
  ret  
stackIsEmpty endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Rckgabe: TRUE(=1) wenn Stack voll, ansonsten FALSE (=0)
stackIsFull proc stackAddr:DWORD
assume edx:PTR stack_struct	
	mov edx,stackAddr
	mov eax, FALSE
	mov ecx,[edx].SP_
	cmp ecx,[edx].maxSize
	jb @f
	  mov eax,TRUE
	@@:
	  
	ret

stackIsFull endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Float in ST(0) erwartet
; Rckgabe: keine
; Hint: stackIsFull nutzen!
floatStackPush proc stackAddr:DWORD
assume edx:PTR stack_struct
  mov edx,stackAddr
  mov ecx,[edx].SP_    
  add ecx, sizeof FLOATSIZE
  add [edx].SP_, sizeof FLOATSIZE  
  FSTP FLOATSIZE ptr[ecx]  
  
  ret  
floatStackPush endp

; Parameter: stackAddr: Pointer auf den Speicher, gleiche Adresse wie bei stackNew
; Rueckgabe: Float in ST(0)
; Hint: vorher stackIsEmpty nutzen!

floatStackPop proc stackAddr:DWORD
assume edx:PTR stack_struct
  mov edx,stackAddr
  mov eax,[edx].SP_
  sub [edx].SP_,sizeof FLOATSIZE
  fld FLOATSIZE ptr [eax]
  ret  
floatStackPop endp